/*
 *  ========================================================================
 *  DIScrete event baSed Energy Consumption simulaTor 
 *    					             for Clouds and Federations (DISSECT-CF)
 *  ========================================================================
 *  
 *  This file is part of DISSECT-CF.
 *  
 *  DISSECT-CF is free software: you can redistribute it and/or modify it
 *  under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or (at
 *  your option) any later version.
 *  
 *  DISSECT-CF is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
 *  General Public License for more details.
 *  
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with DISSECT-CF.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  (C) Copyright 2013, Gabor Kecskemeti (gkecskem@dps.uibk.ac.at,
 *   									  kecskemeti.gabor@sztaki.mta.hu)
 */


package hu.mta.sztaki.lpds.cloud.simulator;

import hu.mta.sztaki.lpds.cloud.simulator.util.ReflectiveAction;
import hu.mta.sztaki.lpds.cloud.simulator.util.ReflectiveFastArray;

import java.util.HashMap;

public abstract class Timed implements ReflectiveAction {

	private static HashMap<Thread,ReflectiveFastArray<Timed>> contextList = new HashMap<Thread,ReflectiveFastArray<Timed>>();

	private boolean activeSubscription = false;

	public static ReflectiveFastArray<Timed> getTickers() {
		final Thread tid=Thread.currentThread();
		ReflectiveFastArray<Timed> tickers=contextList.get(tid);
		if(tickers==null) {
			tickers=new ReflectiveFastArray<Timed>(new Timed[500]);
			contextList.put(tid, tickers);
		}
		return tickers;
	}

	protected final void subscribe() {
		if (activeSubscription)
			return;
		getTickers().add(this);
		activeSubscription = true;
	}

	protected final void unsubscribe() {
		if (activeSubscription) {
			getTickers().remove(this);
			activeSubscription = false;
		}
	}

	public abstract void eval();
}
